#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Wed Mar 16 11:01:01 2011
import matplotlib
matplotlib.use('WXAgg')
from matplotlib.backends.backend_wxagg import FigureCanvasWxAgg as FigureCanvas
from matplotlib.backends.backend_wx import NavigationToolbar2Wx
import wx
import wx.propgrid
from wx.lib import sheet
import element
import connection
import notif
import project
import prop
import os # New! Manon need
import datetime
import wx.lib.newevent
import logging
import math

# create event type
wxLogEvent, EVT_WX_LOG_EVENT = wx.lib.newevent.NewEvent()
# create logger 
logger = logging.getLogger()


def sortBykey(dikt):
#method that sort dikt by keys
	lyst = list()
	length = len(dikt)
	for i in range(length):
		lyst.append(0)
	for x in dikt:
		lyst[dikt[x].labelKey]=x
	return lyst

def isSelectable(obj):
#Return true if obj is selectable
	if type(obj) != type(None) and type(obj) != connection.Connection:
		return True
	else :
		return False

def isDragable(obj):
#return true if obj is drang and dropable
	if type(obj) != type(None) and type(obj) != connection.Connection:
		return True
	else :
		return False

def isConnectable(obj):
#return true if obj can be connected
	if type(obj) == connection.Connection:
		return True
	else :
		return False


class MySummaryPanelState(wx.grid.Grid,notif.Notifiable):
	''' Panel that contain the grid with all state'''
	def __init__(self,frame, parent,id):
		wx.grid.Grid.__init__(self,parent)
		notif.Notifiable.__init__(self)
		self.frame = frame
		self.project = self.frame.app.project
		self.project.addNotif(self)
		self.Bind(wx.grid.EVT_GRID_CELL_CHANGE,self.OnChange)
		self.Bind(wx.grid.EVT_GRID_CELL_LEFT_DCLICK,self.OnDoubleClick)
		self.lyst = ['name','temperature','pressure','quality','enthalpy','entropy','exergy','specific volume','I1','O1']
		self.CreateGrid(1,len(self.lyst))
		self.SetRowLabelSize(0) #permet de ne pas afficher la premiere colonne
		i = 0
		for x in self.lyst:
			self.SetColLabelValue(i,x)
			i += 1
	        for x in range(len(self.lyst)):
	            self.SetColSize(x, 110)


	def OnChange(self,evt):
		row,col = evt.GetRow(),evt.GetCol()
		if col<6 :
			elem = self.project.elemList[self.GetRowLabelValue(row)]
			elem.properties[self.GetColLabelValue(col)].impose((self.GetCellValue(row,col)))
	
	def OnDoubleClick(self,evt):
		#Allow to travel between element
		row,col = evt.GetRow(),evt.GetCol()
		if col>=7:
			elem = self.GetCellValue(row,col)
			if elem != None:
				for x in self.project.elemList:
					if str(x) == elem:
						if self.project.currentElem != None: 
							self.project.currentElem.deselect()
						self.project.currentElem = self.project.elemList[x]
						self.project.elemList[x].select()
		else :
			elem = self.GetRowLabelValue(row)
			if elem != None:
				for x in self.project.elemList:
					if str(x) == elem:
						if self.project.currentElem != None: 
							self.project.currentElem.deselect()
						self.project.currentElem = self.project.elemList[x]
						self.project.elemList[x].select()
		

	def OnNotif(self):
		#Delete previous Grid
		numRows = self.GetNumberRows()
		if numRows != 0:
			for z in range(0,numRows):
				self.DeleteRows(0,1)
		#Create new grid with updated value
		#sortedList ne fonctionne pas car les elem n'ont pas de key
		i = 0
		for x in self.project.elemList:
			if self.project.elemList[x].genericName() == 'state':
				self.AppendRows(1)
				self.SetRowLabelValue(i,x)
				j = 0
				for z in self.lyst:
					if z != 'I1' and z != 'O1':
						value = self.project.elemList[x].properties[z].value
						if value != None and z != 'name' and z != 'quality' and z!= 'specific volume':
							stringvalue = str('%0.2f'%value) #set two digits after decimal
						elif value != None and z == 'specific volume':
							stringvalue = str('%0.4f'%value)
						elif z == 'name':
							stringvalue = str(value)
						elif z == 'quality':
							if value != None:
								if  math.isnan(float(value)) :
									stringvalue = str(prop.qualityKind(self.project.elemList[x].properties[z]))
								else :
									stringvalue = str('%0.5f'%value)
							else :
								stringvalue = str(value)
						else :
							stringvalue = str(None)
						self.SetCellTextColour(i,j,self.project.elemList[x].properties[z].colour())
						self.SetCellValue(i,j,stringvalue)
					else:
						link = self.project.elemList[x].connection[z].link
						if link != None:
							self.SetCellValue(i,j,str(self.project.nameList[link.elem]))
						else :
							self.SetCellValue(i,j,'Not connected')

					j += 1
				i += 1

		
class MyAnalysisPanel(wx.Panel):
	'''Panel that contains piechart'''
	def __init__(self,frame, parent, id):
		wx.Panel.__init__(self,parent,id)
		self.frame = frame
		self.project = self.frame.app.project
		#self.SetBackgroundColour('WHITE')
		self.figure = matplotlib.figure.Figure()
		self.subplot = self.figure.add_subplot(111)
		t = []
		self.subplot.pie(t)
		self.canvas = FigureCanvas(self, -1, self.figure)
		self.sizer = wx.BoxSizer(wx.VERTICAL)
		self.sizer.Add(self.canvas, 1, wx.LEFT | wx.TOP | wx.GROW)
		self.SetSizer(self.sizer)
		self.Fit()
		self.Show(True)
		self.add_toolbar()

	def add_toolbar(self):
		self.toolbar = NavigationToolbar2Wx(self.canvas)
		self.toolbar.Realize()
		# On Windows platform, default window size is incorrect, so set
		# toolbar width to figure width.
		tw, th = self.toolbar.GetSizeTuple()
		fw, fh = self.canvas.GetSizeTuple()
		# By adding toolbar in sizer, we are able to put it at the bottom
		# of the frame - so appearance is closer to GTK version.
		# As noted above, doesn't work for Mac.
		self.toolbar.SetSize(wx.Size(fw, th))
		self.sizer.Add(self.toolbar, 0, wx.LEFT | wx.EXPAND)
		# update the axes menu on the toolbar
		self.toolbar.update()

	def OnPaint(self, event):
		self.canvas.draw()

	def OnPageChange(self):
		self.subplot.cla()
		t = []
		label = []
		i = 0
		j = 0
		for x in self.project.elemList:
			for y in self.project.elemList[x].properties:
				if y == 'power' and x[:6] != 'boiler':
					i += 1
					if self.project.elemList[x].properties[y].value != None:
						j += 1
						t.append(abs(self.project.elemList[x].properties[y].value))
						label.append(x)
				elif y == 'power lost':
					i += 1
					if self.project.elemList[x].properties[y].value != None:
						j += 1
						t.append(abs(self.project.elemList[x].properties[y].value))
						label.append(x+' lost')
		print i, j
		if i != j:
			logger.info('All the powers have not been computed')
			self.subplot.pie([0])
		elif i != 0:
			logger.info('All the powers have been computed')
			self.subplot.pie(t,labels = label)
		else :
			pass
		self.figure.suptitle('Energy Balance',fontsize = 12)
		self.canvas.draw()
		self.Refresh()



class MyCyclePanel(wx.Panel,notif.Notifiable):
	''' Panel that contain  cycle'''
	def __init__(self,frame,parent,id):
		wx.Panel.__init__(self,parent,id)
		notif.Notifiable.__init__(self)
		self.frame = frame
		self.project = self.frame.app.project
		self.project.addNotif(self)
		self.Bind(wx.EVT_LEFT_DOWN,self.OnLeftDown)
		self.Bind(wx.EVT_MOTION,self.OnMouseMove)
		self.Bind(wx.EVT_LEFT_UP,self.OnLeftUp)
		self.Bind(wx.EVT_RIGHT_UP,self.OnRightUp)
		self.Bind(wx.EVT_KEY_DOWN,self.OnKeyDown)
		self.Bind(wx.EVT_KEY_UP,self.OnKeyUp)
		self.Bind(wx.EVT_PAINT,self.OnPaint)
		self.checkCycle = {'draganddrop':None,'onArrow':False,'onArrowFirstConn':None,'dpos':(0,0)}
		self.checkCycleKey = {'control' : False}


	def OnLeftDown(self,event):
		posEvent =  event.GetPosition().Get()
		obj = self.project.isZoneClick(posEvent)
		#DRAG AND DROP
		if isDragable(obj):
			dx = posEvent[0]-obj.pos[0]
			dy = posEvent[1]-obj.pos[1]
			self.checkCycle['dpos'] = (dx,dy)

			self.checkCycle['draganddrop'] = obj
		
	def OnMouseMove(self,event):
		if self.checkCycle['draganddrop'] != None:
			posEvent = event.GetPosition().Get()
			self.checkCycle['draganddrop'].pos = (posEvent[0]-self.checkCycle['dpos'][0],posEvent[1]-self.checkCycle['dpos'][1])
			self.Refresh()

	def OnRightUp(self,event):
		#Deconnect connection if click with right mouseon it
		posEvent =  event.GetPosition().Get()
		obj = self.project.isZoneClick(posEvent)
		if isConnectable(obj):
			if obj.link != None:
				elem_a = obj.elem
				elem_b = obj.link.elem
				elem_a.connect(obj,None)
				self.Refresh()
		elif isSelectable(obj):
			self.project.removeElem(self.project.nameList[obj])

	def OnLeftUp(self,event):
		posEvent =  event.GetPosition().Get()
		obj = self.project.isZoneClick(posEvent)
		self.checkCycle['dpos'] = None
		if self.checkCycle['draganddrop'] != None:
			self.checkCycle['draganddrop'] = None
		#si on veut pas de selection apres un dandd, il faut mettre elif dans la creation de composants, mais alors les selection se font en doubleckick O_o

		#CREATION COMPOSANTS
		elif self.frame.window_4.checkBibli['composant'] != None:
			self.project.createElem(self.frame.window_4.checkBibli['composant'],posEvent)
			self.frame.window_4.checkBibli['composant'] = None
		#SELECTION - DISPLAY PROPRIETES
		elif isSelectable(obj) and self.checkCycle['onArrow'] == False :
			if self.project.currentElem == obj:
				obj.deselect()
			elif self.project.currentElem != None and self.checkCycleKey['control'] == False:
				self.project.currentElem.deselect()
				self.project.currentElem = obj
				obj.select()
				"""doit se faire ici et pas dans elem.select(), car en cas de selection multiple ou l'on utilise elem.select() aussi, il ne faut pas changer l'elem current
				autre remarque : le elem.select() doit se faire apres que le currentelem soit changer, car c'est select() qui contient de doNotify"""
			elif self.project.currentElem != None and self.checkCycleKey['control'] == True :
				obj.select()
			elif self.project.currentElem == None :
				self.project.currentElem = self.project.isZoneClick(posEvent)
				self.project.isZoneClick(posEvent).select()
		#DESELECTION DE TOUT LES ELEMENTS
		elif obj == None :
			for z in self.project.elemList :
				self.project.elemList[z].deselect()
		# CONNECT ELEMENTS
		elif isConnectable(obj) and self.checkCycle['onArrow'] == True :
			if self.checkCycle['onArrowFirstConn'] == None:
				self.checkCycle['onArrowFirstConn'] = obj
			elif self.checkCycle['onArrowFirstConn'] != None:
				conn1 = self.checkCycle['onArrowFirstConn']
				conn2 = obj
				if type(conn1) == type(conn2) :
					self.checkCycle['onArrowFirstConn'].elem.connect(conn1,conn2)
				else :
					logger.info('Please select a connection not an element')
				self.checkCycle['onArrowFirstConn'] = None
		self.Refresh()


	def OnKeyDown(self,event):
		key = event.GetKeyCode()
		if key == wx.WXK_DELETE:
			self.project.removeSelectedElem()				

		elif key == wx.WXK_CONTROL:
			self.checkCycleKey['control'] = True			

	def OnKeyUp(self,event):
		key = event.GetKeyCode()
		if key == wx.WXK_CONTROL:
			self.checkCycleKey['control'] = False

	def OnPaint(self,event):
		#Dessine a partir de elemList les elements et de arrowList les fleches
		newpaintdc = wx.PaintDC(self)
		newpaintdc.Clear()
		for z in self.project.elemList:
			for y in self.project.elemList[z].connection :

				#Draw Connection's Element
				newpaintdc.DrawBitmap(self.project.elemList[z].connection[y].bmp,self.project.elemList[z].connection[y].dpos[0]+self.project.elemList[z].pos[0],self.project.elemList[z].connection[y].dpos[1]+self.project.elemList[z].pos[1])
				pen = wx.Pen('BLACK',width = 6,style = wx.SOLID) #Set color and width of connection's line

				#Set color and width of connection's line
				#pen = wx.Pen('BLACK',width = 6,style = wx.SOLID) # merge manon sait pas si c le bon >.<

				newpaintdc.SetPen(pen)
				if self.project.elemList[z].connection[y].link != None :
					elem = self.project.elemList[z]
					if elem.genericName != 'state':
						x1 = elem.connection[y].dpos[0]+elem.pos[0]
						y1 = elem.connection[y].dpos[1]+elem.pos[1]
					elif elem.genericName == 'state' :
						x1 = (elem.pos[0]+elem.zone[1][0]/2)
						y1 = (elem.pos[0]+elem.zone[1][1]/2)
					x2 = elem.connection[y].link.dpos[0]+elem.connection[y].link.elem.pos[0]
					y2 = elem.connection[y].link.dpos[1]+elem.connection[y].link.elem.pos[1]
					newpaintdc.DrawLinePoint((x1,y1),(x2,y2))
			#Draw Elements
			newpaintdc.DrawBitmap(self.project.elemList[z].bmp,self.project.elemList[z].pos[0],self.project.elemList[z].pos[1], True)
			for y in self.project.elemList[z].connection :
				#Draw Connection's Element
				newpaintdc.DrawBitmap(self.project.elemList[z].connection[y].bmp,self.project.elemList[z].connection[y].dpos[0]+self.project.elemList[z].pos[0],self.project.elemList[z].connection[y].dpos[1]+self.project.elemList[z].pos[1])



	def OnNotif(self):
		self.Refresh()


class MyBibliPanel(wx.ScrolledWindow):
	""" Panel which contains the cycle component library """
	def __init__(self,frame, parent,id):
		wx.ScrolledWindow.__init__(self, parent = parent, id = -1)
		numberOfelement = len(frame.app.id2type)
		height = 40
		self.SetScrollbars(0,height,0,numberOfelement)
		self.frame = frame
		self.checkBibli = {'composant':None}
		templist = list()

		for elem in self.frame.app.id2type:
			templist.append((elem,self.frame.app.id2type[elem]))
		templist.sort()
		x = 0
		y = 0
		for z in templist:
			button = wx.Button(self,id=-1,label=z[0],pos=(x,y),size=(140,height),name=z[0])
			self.Bind(wx.EVT_BUTTON, self.OnElem,button)
			x = 0
			y += height

	def OnElem(self,event):
		bmpButton = event.GetEventObject()
		elemName = bmpButton.GetName()
		for elem in self.frame.app.id2type:
			if elem == elemName:
				self.checkBibli['composant'] = self.frame.app.id2type[elem]



class MyPropertyGrid(wx.Panel, notif.Notifiable):
	''' Panel that contains a grid with properties of selected element '''
	def __init__(self,frame,parent,id):
		wx.Panel.__init__(self,parent,id)
		notif.Notifiable.__init__(self)
		self.frame = frame
		self.project = self.frame.app.project
		self.project.addNotif(self)
		self.propertygridsizer = wx.BoxSizer(wx.VERTICAL)
		self.SetSizer(self.propertygridsizer)

	def OnNotif(self):
		self.propertygridsizer.Clear()
		self.mypropertygrid = wx.propgrid.PropertyGridManager(self,style=wx.propgrid.PG_SPLITTER_AUTO_CENTER|wx.propgrid.PG_TOOLBAR)
		self.mypropertygrid.Bind(wx.propgrid.EVT_PG_SELECTED,self.OnSelected)
		self.mypropertygrid.Bind(wx.propgrid.EVT_PG_DOUBLE_CLICK,self.OnDoubleClick)
		self.mypropertygrid.Bind(wx.propgrid.EVT_PG_CHANGED,self.OnValueChange)

		if self.project.currentElem != None :
			self.mypropertygrid.Append(wx.propgrid.PropertyCategory(self.project.nameList[self.project.currentElem]))
			#DISLPAY PROPERTIES EXCEPT REFERENCE
			sortedPropList = sortBykey(self.project.currentElem.properties)
			for x in sortedPropList:
				if x[:9] != 'reference' :
					a = self.mypropertygrid.Append(self.project.currentElem.properties[x].display)
					a.SetTextColour(self.project.currentElem.properties[x].colour())

			#DISPLAY CONNECTIONS
			self.mypropertygrid.Append(wx.propgrid.PropertyCategory('Connections'))
			for x in self.project.currentElem.connection:
				if self.project.currentElem.connection[x].link != None:
					self.mypropertygrid.Append(wx.propgrid.StringProperty(x,value=str(self.project.nameList[self.project.currentElem.connection[x].link.elem])))
				else :
					self.mypropertygrid.Append(wx.propgrid.StringProperty(x,value=''))
			#DISPLAY REFERENCE
			self.mypropertygrid.Append(wx.propgrid.PropertyCategory('Reference'))
			for x in sortedPropList:
				if x[0:9] == 'reference':
					a = self.mypropertygrid.Append(self.project.currentElem.properties[x].display)
					a.SetTextColour(self.project.currentElem.properties[x].colour())

		else:
			self.mypropertygrid.Append(wx.propgrid.StringProperty('No current element',value = 'Please select an element'))


		self.propertygridsizer.Add(self.mypropertygrid,1,wx.EXPAND)
		self.Layout()
		
	def OnSelected(self,event):
		#event.GetProperty() event.GetPropertyName() event.GetPropertyValue()
		#print("Selection :",event.GetPropertyName,"\nvalue :",event.GetPropertyValue())
		pass

	def OnDoubleClick(self,event):
		#Allow to travel between element
		if event.GetPropertyValue() != None:
			for x in self.project.elemList:
				if str(x) == event.GetPropertyValue():
					self.project.currentElem.deselect()
					self.project.currentElem = self.project.elemList[x]
					self.project.elemList[x].select()

	def OnValueChange(self,event):
		#Impose new value given by user
		propName = event.GetProperty().GetLabel()
		prop = self.project.currentElem.properties[propName]
		if propName == 'fluid':
			num = event.GetPropertyValue()
			fluidname = self.project.app.fluidListName[num]
			val = self.project.app.fluidList[fluidname]
			prop.impose(val)
		elif propName == 'reference state':
			val = event.GetPropertyValue()
			if val == True :
				prop.impose(val)
			else:
				prop.impose('')
		else:
			val = str(event.GetPropertyValue())
			prop.impose(val)



class wxLogHandler(logging.Handler):
    """
    A handler class which sends log strings to a wx object
    """
    def __init__(self, wxDest=None):
        """
        Initialize the handler
        @param wxDest: the destination object to post the event to 
        @type wxDest: wx.Window
        """
        logging.Handler.__init__(self)
        self.wxDest = wxDest
        self.level = logging.DEBUG

    def flush(self):
        """
        does nothing for this handler
        """
	pass


    def emit(self, record):
        """
        Emit a record.

        """
        try:
            msg = self.format(record)
            evt = wxLogEvent(message=msg,levelname=record.levelname)            
            wx.PostEvent(self.wxDest,evt)
        except (KeyboardInterrupt, SystemExit):
            raise
        except:
            self.handleError(record)


class MyStatusPanel(wx.ScrolledWindow,notif.Notifiable):
	''' Panel that inform user with log '''
	def __init__(self,frame,parent,id):
		notif.Notifiable.__init__(self)
		wx.ScrolledWindow.__init__(self,parent,id)
		width,height = self.GetSizeTuple()
		self.SetScrollbars(10,10,50,0)
		self.Bind(EVT_WX_LOG_EVENT, self.onLogEvent)
		self.SetBackgroundColour('BLACK')
		self.SetForegroundColour('WHITE')

		date = datetime.date.today().timetuple()

		date = datetime.datetime.now().strftime("%d-%m-%y ~ %Hh%M ")
		self.startText = 'Welcome to UCycLe\n'+date+'\n'
		self.disp = wx.StaticText(self,-1,self.startText)
		self.logtext = []

		# create logger
		self.logger = logging.getLogger()
		self.logger.setLevel(logging.DEBUG)
		# create custom handler and set level to debug
		self.ch = wxLogHandler(self)
		self.ch.setLevel(logging.DEBUG)
		# create formatter
		#self.formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
		#self.formatter = logging.Formatter('%(asctime)s - %(message)s',datefmt='%d-%m-%Y - %H h %M')
		self.formatter = logging.Formatter('%(message)s')
		# add formatter to ch
		self.ch.setFormatter(self.formatter)
		# add ch to logger
		self.logger.addHandler(self.ch)



	def onLogEvent(self,event):
		pass
		'''
		Add event.message to text window
		'''
		tempText = self.disp
		msg = event.message.strip("\r")+'\n'
		self.logtext.append(msg)
		disptext = str()
		if len(self.logtext) >5:
			for i in range(1,6):
				disptext += self.logtext[len(self.logtext)-i]
		else:
			for i in range(len(self.logtext)):
				disptext = self.logtext[i]
		wx.StaticText.SetLabel(self.disp,str(disptext))


class MyFrame(wx.Frame):
    ''' Principal frame of the interface '''
    def __init__(self,app, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.CAPTION|wx.CLOSE_BOX|wx.MINIMIZE_BOX|wx.MAXIMIZE|wx.MAXIMIZE_BOX|wx.SYSTEM_MENU|wx.RESIZE_BORDER|wx.FULL_REPAINT_ON_RESIZE|wx.CLIP_CHILDREN
        wx.Frame.__init__(self,parent = None, *args, **kwds)
        self.app = app
	self.project = self.app.project
        # Menu Bar
        self.frame_1_menubar = wx.MenuBar()
        global ID_NEW; ID_NEW = wx.NewId()
        global ID_OPEN; ID_OPEN = wx.NewId()
        global ID_SAVEAS; ID_SAVEAS = wx.NewId()
        global ID_PRINT; ID_PRINT = wx.NewId()
        global ID_EXIT; ID_EXIT = wx.NewId()
        global ID_ABOUT; ID_ABOUT = wx.NewId()
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(ID_NEW, "&New", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(ID_OPEN, "&Open", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(ID_SAVEAS, "&Save As", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(ID_PRINT, "&Print", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(ID_EXIT, "&Quit", "", wx.ITEM_NORMAL)
        self.frame_1_menubar.Append(wxglade_tmp_menu, "&File")
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(ID_ABOUT, "&About", "", wx.ITEM_NORMAL)
        self.frame_1_menubar.Append(wxglade_tmp_menu, "&Help")
        self.SetMenuBar(self.frame_1_menubar)
        # Menu Bar end
        
        # Tool Bar
        self.frame_1_toolbar = wx.ToolBar(self, -1)
        self.SetToolBar(self.frame_1_toolbar)
        global ID_CYCLE; ID_CYCLE = wx.NewId()
        global ID_DATA; ID_DATA = wx.NewId()
        global ID_ANALYSE; ID_ANALYSE = wx.NewId()
        global ID_ARROW; ID_ARROW = wx.NewId()
        self.frame_1_toolbar.AddLabelTool(ID_OPEN, "open", wx.Bitmap("images/toolbar/open.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, "Open a project", "")
        self.frame_1_toolbar.AddSeparator()
        self.frame_1_toolbar.AddLabelTool(ID_CYCLE, "cycle", wx.Bitmap("images/toolbar/cycle.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, "Display cycle", "")
        self.frame_1_toolbar.AddLabelTool(ID_DATA, "Data", wx.Bitmap("images/toolbar/data.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, "Display states panel", "")
        self.frame_1_toolbar.AddLabelTool(ID_ANALYSE, "Analyse", wx.Bitmap("images/toolbar/piechart.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, "Display energy balance", "")
        self.frame_1_toolbar.AddSeparator()
        self.frame_1_toolbar.AddLabelTool(ID_ARROW, "Arrow", wx.Bitmap("images/toolbar/fleche.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_CHECK, "Allow to connect element", "")
        # Tool Bar end
        self.window_1 = MyStatusPanel(self, self, -1)
        self.window_2 = MyPropertyGrid(self, self, -1)
        self.notebook_1 = wx.Notebook(self, -1, style=0)
        self.notebook_1_pane_1 = wx.Panel(self.notebook_1, -1)
        self.window_3 = MyCyclePanel(self, self.notebook_1_pane_1, -1)
        self.window_4 = MyBibliPanel(self, self.notebook_1_pane_1, -1)
        self.notebook_1_pane_2 = wx.Panel(self.notebook_1, -1)
        self.window_6 = MySummaryPanelState(self, self.notebook_1_pane_2, -1)
        self.notebook_1_pane_3 = wx.Panel(self.notebook_1, -1)
        self.window_5 = MyAnalysisPanel(self, self.notebook_1_pane_3, -1)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.OnNew, id=ID_NEW)
        self.Bind(wx.EVT_MENU, self.OnOpen, id=ID_OPEN)
        self.Bind(wx.EVT_MENU, self.OnSaveAs, id=ID_SAVEAS)
        self.Bind(wx.EVT_MENU, self.OnPrint, id=ID_PRINT)
        self.Bind(wx.EVT_MENU, self.OnQuit, id=ID_EXIT)
        self.Bind(wx.EVT_MENU, self.OnAbout, id=ID_ABOUT)
        self.Bind(wx.EVT_TOOL, self.OnOpen, id=ID_OPEN)
        self.Bind(wx.EVT_TOOL, self.OnCycle, id=ID_CYCLE)
        self.Bind(wx.EVT_TOOL, self.OnData, id=ID_DATA)
        self.Bind(wx.EVT_TOOL, self.OnAnalyse, id=ID_ANALYSE)
        self.Bind(wx.EVT_TOOL, self.OnArrow, id=ID_ARROW)
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGING, self.OnPageChanging, self.notebook_1)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("frame_1")
        self.SetSize((800, 600))
        self.frame_1_toolbar.SetToolBitmapSize((20, 20))
        self.frame_1_toolbar.Realize()
        self.window_3.SetFocus()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_1 = wx.GridSizer(1, 1, 0, 0)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_2.Add(self.window_1, 1, wx.EXPAND, 0)
        sizer_2.Add(self.window_2, 3, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_3.Add(self.window_3, 6, wx.EXPAND, 0)
        sizer_3.Add(self.window_4, 1, wx.EXPAND, 0)
        self.notebook_1_pane_1.SetSizer(sizer_3)
        grid_sizer_1.Add(self.window_6, 1, wx.EXPAND, 0)
        self.notebook_1_pane_2.SetSizer(grid_sizer_1)
        sizer_4.Add(self.window_5, 1, wx.EXPAND, 0)
        self.notebook_1_pane_3.SetSizer(sizer_4)
        self.notebook_1.AddPage(self.notebook_1_pane_1, "Cycle")
        self.notebook_1.AddPage(self.notebook_1_pane_2, "Summary")
        self.notebook_1.AddPage(self.notebook_1_pane_3, "Analysis")
        sizer_1.Add(self.notebook_1, 2, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        self.Layout()
        # end wxGlade

    def saveAs(self):	# ajout de Manon
	dlg = wx.FileDialog( self, "Save project as ...", ' ', "", "*.*", wx.SAVE | wx.OVERWRITE_PROMPT)
	if dlg.ShowModal() == wx.ID_OK:
		val = dlg.GetMessage()
		saveName=dlg.GetFilename()
		dirName=dlg.GetDirectory()
		filehandle= self.project.saveProject(saveName, dirName)
	dlg.Destroy()
	
    def OnNew(self, event): # wxGlade: MyFrame.<event_handler>
	exitDlg = wx.MessageDialog( self, "The document has been modified.\n Do you want to save it?\n","Confirm", wx.YES_NO)
	gotcha = exitDlg.ShowModal()
	if gotcha == wx.ID_YES:
		self.OnSaveAs(wx.ID_YES)
	elif gotcha == wx.ID_NO:
		pass
	self.project.newProject()

    def OnOpen(self, event): # wxGlade: MyFrame.<event_handler>
	self.OnNew(event)
	dlg = wx.FileDialog(self, "Choose a file", ' ', "", "*.*", wx.OPEN)
	if dlg.ShowModal() == wx.ID_OK:
		fileName=dlg.GetFilename()
		dirName=dlg.GetDirectory()
		self.project.openProject(fileName, dirName)
	dlg.Destroy()


    def OnSaveAs(self, event): # wxGlade: MyFrame.<event_handler>
        self.saveAs()

    def OnQuit(self, event): # wxGlade: MyFrame.<event_handler>
	exitDlg = wx.MessageDialog( self, "Are you sure you want to quit ?\n","Confirm", wx.YES_NO)
	gotcha = exitDlg.ShowModal()
	if gotcha == wx.ID_YES:
		self.Close(True)


    def OnCycle(self, event): # wxGlade: MyFrame.<event_handler>
	self.notebook_1.ChangeSelection(0)

    def OnData(self, event): # wxGlade: MyFrame.<event_handler>
	self.notebook_1.ChangeSelection(1)

    def OnAbout(self, event): # wxGlade: MyFrame.<event_handler>
         about_text = 'Bienvenue sur UCycLE,\n le logiciel de calcul de cycle thermique moteur.'
         dial = wx.MessageDialog(None, about_text, 'Info', wx.OK) 
         dial.ShowModal()

    def OnAnalyse(self, event): # wxGlade: MyFrame.<event_handler>
	self.notebook_1.ChangeSelection(2)


    def OnArrow(self, event): # wxGlade: MyFrame.<event_handler>
	if self.window_3.checkCycle['onArrow'] == True :
		self.window_3.checkCycle['onArrow'] = False
		self.window_3.checkCycle['onArrowFirstElem'] = None
	elif self.window_3.checkCycle['onArrow'] == False:
		self.window_3.checkCycle['onArrow'] = True
	else:
		logger.info('Error in Arrow')
    def OnTab(self, event): # wxGlade: MyFrame.<event_handler>
	if self.notebook_1.GetSelection() == 0 :
		self.window_3.Refresh()


    def OnPageChanging(self, event): # wxGlade: MyFrame.<event_handler>
	if event.GetSelection() == 2:
		self.window_5.OnPageChange()

    def OnPrint(self, event): # wxGlade: MyFrame.<event_handler>
        self.app.project.exportData()

# end of class MyFrame


'''if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()'''
